Freeciv-3.2: city Struct Reference

Freeciv-3.2

Loading...
Searching...
No Matches
Data Fields
city Struct Reference

`#include <city.h>`

## Data Fields

char * | name
struct tile * | tile
struct player * | owner
struct player * | original
int | id
int | style
enum capital_type | capital
enum city_acquire_type | acquire_t
citizens | size
citizens | feel [CITIZEN_LAST][FEELING_LAST]
citizens | specialists [SP_MAX]
citizens | martial_law
citizens | unit_happy_upkeep
citizens * | nationality
struct trade_route_list * | routes
struct tile_cache * | tile_cache
int | tile_cache_radius_sq
int | surplus [O_LAST]
int | waste [O_LAST]
int | unhappy_penalty [O_LAST]
int | prod [O_LAST]
int | citizen_base [O_LAST]
int | usage [O_LAST]
int | bonus [O_LAST]
int | abs_bonus [O_LAST]
int | food_stock
int | shield_stock
int | pollution
int | illness_trade
int | turn_plague
int | city_radius_sq
int | airlift
bool | did_buy
bool | did_sell
bool | was_happy
bool | had_famine
int | anarchy
int | rapture
int | turn_founded
int | turn_last_built
int | before_change_shields
int | caravan_shields
int | disbanded_shields
int | last_turns_shield_surplus
struct built_status | built [B_LAST]
struct universal | production
struct universal | changed_from
struct worklist | worklist
bv_city_options | city_options
enum city_wl_cancel_behavior | wlcb
struct unit_list * | units_supported
int * | counter_values
int | history
struct worker_task_list * | task_reqs
int | steal
struct { |
size_t length |
bool persistent |
bool vigilant |
struct unit_order * orders |
} | rally_point |
struct cm_parameter * | cm_parameter
union { |
struct { |
float migration_score |
int mgr_score_calc_turn |
int illness |
int workers_frozen |
enum city_needs_arrange needs_arrange |
bool needs_refresh |
bool synced |
bool debug |
struct adv_city * adv |
void * ais [FREECIV_AI_MOD_LAST] |
struct vision * vision |
} server |
struct { |
bool occupied |
int walls |
bool happy |
bool unhappy |
int city_image |
int culture |
int buy_cost |
bool colored |
int color_index |
struct unit_list * info_units_supported |
struct unit_list * info_units_present |
struct unit_list * collecting_info_units_supported |
struct unit_list * collecting_info_units_present |
enum city_updates need_updates |
unsigned char first_citizen_index |
} client |
}; |  |

## Detailed Description

Definition at line 320 of file city.h.

## Field Documentation

## ◆ [union]

union { ... } city

## ◆ abs_bonus

int city::abs_bonus[O_LAST]

Definition at line 364 of file city.h.

Referenced by create_city_virtual(), set_city_bonuses(), and set_city_production().

## ◆ acquire_t

enum city_acquire_type city::acquire_t

Definition at line 329 of file city.h.

Referenced by create_city_virtual(), dai_can_requirement_be_met_in_city(), sg_load_player_city(), sg_load_player_city(), and transfer_city().

## ◆ adv

struct adv_city* city::adv

Definition at line 452 of file city.h.

Referenced by adjust_improvement_wants_by_effects(), adv_city_alloc(), adv_city_free(), adv_city_update(), adv_city_worker_act_get(), adv_city_worker_act_set(), adv_city_worker_extra_get(), adv_city_worker_extra_set(), adv_city_worker_rmextra_get(), adv_city_worker_rmextra_set(), assess_danger(), building_advisor(), building_advisor_choose(), city_map_update_radius_sq(), dai_build_adv_override(), dai_caravan_can_trade_cities_diff_cont(), dai_choose_help_wonder(), dai_wonder_city_distance(), military_advisor_choose_build(), and sg_load_player_city().

## ◆ airlift

int city::airlift

Definition at line 378 of file city.h.

Referenced by get_airlift_text(), get_city_dialog_airlift_text(), get_city_dialog_airlift_value(), handle_city_info(), package_city(), real_menus_update(), sg_load_player_city(), sg_load_player_city(), and update_city_activity().

## ◆ ais

void* city::ais[FREECIV_AI_MOD_LAST]

Definition at line 453 of file city.h.

Referenced by city_ai_data(), and city_set_ai_data().

## ◆ anarchy

int city::anarchy

Definition at line 384 of file city.h.

Referenced by city_can_buy(), dai_spend_gold(), really_handle_city_buy(), sg_load_player_city(), sg_load_player_city(), and update_city_activity().

## ◆ before_change_shields

int city::before_change_shields

Definition at line 389 of file city.h.

Referenced by city_build_building(), city_build_unit(), city_change_production_penalty(), city_distribute_surplus_shields(), define_orig_production_values(), handle_city_info(), handle_edit_city(), nullify_prechange_production(), package_city(), sg_load_player_city(), and sg_load_player_city().

## ◆ bonus

int city::bonus[O_LAST]

Definition at line 363 of file city.h.

Referenced by cm_state_init(), create_city_virtual(), estimate_fitness(), get_city_dialog_output_text(), set_city_bonuses(), set_city_production(), and windfall_benefit().

## ◆ built

struct built_status city::built[B_LAST]

Definition at line 394 of file city.h.

Referenced by city_add_improvement(), city_has_building(), city_remove_improvement(), create_city_virtual(), handle_city_info(), objbind_get_value_from_object(), objbind_pack_current_values(), sg_load_player_city(), sg_load_player_city(), transfer_city(), and update_improvement_from_packet().

## ◆ buy_cost

int city::buy_cost

Definition at line 466 of file city.h.

Referenced by append_city_buycost_string(), city_dialog::buy(), buy_callback(), city_buy_cost_compare(), city_can_buy(), cityrep_buy(), cr_entry_build_cost(), handle_city_info(), popup_hurry_production_dialog(), city_dialog::update_buy_button(), and update_total_buy_cost().

## ◆ capital

enum capital_type city::capital

Definition at line 328 of file city.h.

Referenced by api_methods_is_primary_capital(), center_next_player_capital(), civil_war(), create_city_virtual(), handle_city_info(), handle_city_short_info(), is_capital(), key_center_capital(), package_city(), player_primary_capital(), transfer_city(), and update_dumb_city().

## ◆ caravan_shields

int city::caravan_shields

Definition at line 390 of file city.h.

Referenced by city_change_production_penalty(), handle_city_info(), nullify_caravan_and_disband_plus(), package_city(), sg_load_player_city(), and sg_load_player_city().

## ◆ changed_from

struct universal city::changed_from

Definition at line 399 of file city.h.

Referenced by city_change_production_penalty(), define_orig_production_values(), handle_city_info(), package_city(), sg_load_player_city(), and sg_load_player_city().

## ◆ citizen_base

int city::citizen_base[O_LAST]

Definition at line 359 of file city.h.

Referenced by city_refresh_from_main_map(), compute_max_stats_heuristic(), get_city_dialog_output_text(), handle_city_info(), package_city(), and set_city_production().

## ◆ city_image

int city::city_image

Definition at line 464 of file city.h.

Referenced by get_city_sprite(), handle_city_info(), and handle_city_short_info().

## ◆ city_options

bv_city_options city::city_options

Definition at line 403 of file city.h.

Referenced by create_city_options_widget_list(), handle_city_info(), handle_city_options_req(), is_city_option_set(), misc_panel_city_dlg_callback(), package_city(), sg_load_player_city(), and sg_load_player_city().

## ◆ city_radius_sq

int city::city_radius_sq

Definition at line 375 of file city.h.

Referenced by apply_solution(), city_map_radius_sq_get(), city_map_radius_sq_set(), create_city_virtual(), handle_city_info(), min_food_surplus_for_fastest_growth(), and package_city().

## ◆ [struct]

struct { ... } city::client

Referenced by api_methods_is_city_happy(), api_methods_is_city_unhappy(), append_city_buycost_string(), city_dialog::buy(), buy_callback(), city_buy_cost_compare(), city_can_buy(), city_dialog_update_information(), city_dialog_update_information(), city_dialog_update_present_units(), city_dialog_update_supported_units(), city_is_occupied(), city_packet_common(), city_report_dialog_update_city(), cityrep_buy(), client_remove_unit(), cr_entry_build_cost(), cr_entry_culture(), cr_entry_performance(), create_city_virtual(), destroy_city_virtual(), fill_city_overlays_sprite_array(), fill_sprite_array(), get_citizen_sprite(), get_city_dialog_culture_text(), get_city_sprite(), handle_city_info(), handle_city_short_info(), handle_investigate_started(), handle_unit_packet_common(), handle_unit_short_info(), is_plr_zoc_client(), num_present_units_in_city(), num_supported_units_in_city(), popup_city_dialog(), popup_hurry_production_dialog(), redraw_army_city_dialog(), redraw_supported_units_city_dialog(), refresh_city_dialog(), show_full_citybar(), toggle_city_color(), city_dialog::update_buy_button(), city_dialog::update_info_label(), update_total_buy_cost(), and city_dialog::update_units().

## ◆ cm_parameter

struct cm_parameter* city::cm_parameter

Definition at line 425 of file city.h.

Referenced by auto_arrange_workers(), destroy_city_virtual(), handle_web_cma_clear(), handle_web_cma_set(), package_city(), sg_load_player_city(), and transfer_city().

## ◆ collecting_info_units_present

struct unit_list* city::collecting_info_units_present

Definition at line 478 of file city.h.

Referenced by city_packet_common(), destroy_city_virtual(), handle_investigate_started(), and handle_unit_short_info().

## ◆ collecting_info_units_supported

struct unit_list* city::collecting_info_units_supported

Definition at line 477 of file city.h.

Referenced by city_packet_common(), destroy_city_virtual(), handle_investigate_started(), and handle_unit_short_info().

## ◆ color_index

int city::color_index

Definition at line 470 of file city.h.

Referenced by fill_city_overlays_sprite_array(), and toggle_city_color().

## ◆ colored

bool city::colored

Definition at line 469 of file city.h.

Referenced by fill_city_overlays_sprite_array(), and toggle_city_color().

## ◆ counter_values

int* city::counter_values

Definition at line 408 of file city.h.

Referenced by api_counter_increase(), api_counter_zero(), api_methods_counter_city_get(), city_counters_refresh(), create_city_virtual(), destroy_city_virtual(), handle_city_update_counters(), sg_load_counters(), transfer_city(), and update_city_activity().

## ◆ culture

int city::culture

Definition at line 465 of file city.h.

Referenced by city_dialog_update_information(), city_dialog_update_information(), cr_entry_culture(), cr_entry_performance(), get_city_dialog_culture_text(), handle_city_info(), and city_dialog::update_info_label().

## ◆ debug

bool city::debug

Definition at line 450 of file city.h.

Referenced by auto_arrange_workers(), citizens_update(), and debug_command().

## ◆ did_buy

bool city::did_buy

Definition at line 379 of file city.h.

Referenced by city_can_buy(), city_can_change_build(), create_city_virtual(), handle_city_info(), package_city(), popup_hurry_production_dialog(), really_handle_city_buy(), sg_load_player_city(), sg_load_player_city(), and update_city_activity().

## ◆ did_sell

bool city::did_sell

Definition at line 380 of file city.h.

Referenced by city_widget::display_list_menu(), enable_city_dlg_widgets(), handle_city_info(), package_city(), really_handle_city_sell(), rebuild_imprm_list(), sell_impr_iterate(), sg_load_player_city(), sg_load_player_city(), test_player_sell_building_now(), and update_city_activity().

## ◆ disbanded_shields

int city::disbanded_shields

Definition at line 391 of file city.h.

Referenced by city_change_production_penalty(), handle_city_info(), nullify_caravan_and_disband_plus(), package_city(), really_handle_city_buy(), sg_load_player_city(), and sg_load_player_city().

## ◆ feel

citizens city::feel[CITIZEN_LAST][FEELING_LAST]

Definition at line 333 of file city.h.

Referenced by adv_eval_calc_city(), citizen_base_mood(), citizen_content_buildings(), citizen_happiness_nationality(), citizen_happy_units(), citizen_happy_wonders(), citizen_luxury_happy(), city_happy(), city_incite_cost(), city_migration_score(), city_unhappy(), cr_entry_angry(), cr_entry_content(), cr_entry_happy(), cr_entry_unhappy(), cr_entry_workers(), dai_content_effect_value(), dai_effect_value(), get_city_citizen_types(), handle_city_info(), handle_city_short_info(), happy_copy(), military_advisor_choose_build(), package_city(), redraw_city_dialog(), redraw_happiness_city_dialog(), and resolve_city_emergency().

## ◆ first_citizen_index

unsigned char city::first_citizen_index

Definition at line 483 of file city.h.

Referenced by city_packet_common(), and get_citizen_sprite().

## ◆ food_stock

int city::food_stock

Definition at line 367 of file city.h.

Referenced by city_dialog_update_information(), city_dialog_update_information(), city_empty_food_stock(), city_increase_size(), city_populate(), city_reduce_size(), city_reset_foodbox(), city_turn_notify(), city_turns_to_grow(), cr_entry_growturns(), dai_effect_value(), get_city_growth_string(), handle_city_info(), handle_edit_city(), min_food_surplus_for_fastest_growth(), objbind_get_value_from_object(), objbind_pack_current_values(), package_city(), redraw_city_dialog(), set_default_city_manager(), sg_load_player_city(), sg_load_player_city(), and city_dialog::update_info_label().

## ◆ had_famine

bool city::had_famine

Definition at line 382 of file city.h.

Referenced by city_populate(), handle_city_info(), package_city(), sg_load_player_city(), sg_load_player_city(), and update_city_activity().

## ◆ happy

bool city::happy

Definition at line 462 of file city.h.

Referenced by api_methods_is_city_happy(), evaluate_solution(), handle_city_info(), and handle_city_short_info().

## ◆ history

int city::history

Definition at line 410 of file city.h.

Referenced by api_edit_city_add_history(), city_culture(), city_history_gain(), cr_entry_history(), cr_entry_performance(), get_city_dialog_culture_text(), handle_city_info(), handle_edit_city(), objbind_get_value_from_object(), objbind_pack_current_values(), package_city(), sg_load_player_city(), sg_load_player_city(), and update_city_activity().

## ◆ id

int city::id

Definition at line 326 of file city.h.

Referenced by actres_possible(), adjust_improvement_wants_by_effects(), adjust_workers_button_pressed(), agents_city_changed(), agents_city_new(), agents_city_remove(), api_edit_perform_action_unit_vs_city(), api_edit_perform_action_unit_vs_city_impr(), api_edit_perform_action_unit_vs_city_tech(), apply_result_on_server(), building_removed(), city_dialog::buy(), caravan_find_best_destination_withtransit(), cause_a_city_changed_for_agent(), center_next_player_capital(), city_build_building(), city_build_unit(), city_buy_production(), city_change_production(), city_change_size(), city_change_specialist(), city_counters_refresh(), city_create_unit(), city_freeze_workers_queue(), city_from_wonder(), city_is_virtual(), city_link(), city_map_update_radius_sq(), city_model_find(), city_model_set(), city_packet_common(), city_populate(), city_reduce_size(), city_refresh_queue_add(), city_dialog::city_rename(), city_rename(), city_sell_improvement(), city_set_worklist(), city_toggle_worker(), citylog_map_workers(), cityopt_callback(), clear_worker_task(), client_plr_tile_city_id_get(), client_remove_city(), clipboard_send_production_packet(), cm_print_city(), cma_is_city_under_agent(), cma_put_city_under_agent(), cma_release_city(), cmafec_get_fe_parameter(), cmafec_set_fe_parameter(), city_map::context_menu(), create_city(), dai_choose_diplomat_offensive(), dai_city_choose_build(), dai_data_phase_begin(), dai_effect_value(), dai_unit_make_homecity(), dai_upgrade_units(), diplomat_investigate(), disband_city(), city_dialog::disband_state_changed(), city_dialog::display_worklist_menu(), do_city_migration(), do_disband_alternative(), do_unit_change_homecity(), domestic_advisor_choose_build(), editor_apply_tool(), find_something_to_kill(), game_remove_city(), handle_city(), handle_city_info(), handle_city_make_specialist(), handle_city_make_worker(), handle_city_remove(), handle_city_short_info(), handle_edit_city_create(), handle_unit_type_upgrade(), idex_register_city(), idex_unregister_city(), is_action_possible(), military_advisor_choose_build(), misc_panel_city_dlg_callback(), impr_item::mouseDoubleClickEvent(), objbind_get_value_from_object(), objbind_pack_current_values(), one_city_trade_benefit(), package_and_send_worker_tasks(), package_city(), place_unit(), popup_incite_dialog(), popup_sabotage_dialog(), rally_set_tile(), real_bodyguard_log(), real_city_report_update_city(), real_menus_update(), reality_check_city(), remove_city(), request_unit_airlift(), request_unit_build_city(), request_unit_change_homecity(), request_unit_upgrade(), city_dialog::save_worklist(), sell_imprvm_dlg_ok_callback(), send_rally_path_orders(), set_city_workertask(), sg_load_player_cities(), sg_load_player_cities(), sg_load_player_city(), sg_load_player_city(), sg_save_map_worked(), spy_send_sabotage_list(), texai_city_destroyed(), texai_city_info_recv(), texai_city_update(), texai_city_worker_requests_create(), text_tag_initv(), text_tag_start_sequence(), throw_units_from_illegal_cities(), transfer_city(), transfer_city_units(), unit_conquer_city(), unit_virtual_create(), units_orders_city_dlg_callback(), update_city_activity(), update_dumb_city(), vision_site_new_from_city(), vision_site_update_from_city(), wonder_built(), wonder_destroyed(), and worklist_change_build_target().

## ◆ illness

int city::illness

Definition at line 434 of file city.h.

Referenced by city_dialog_update_information(), city_dialog_update_information(), city_illness_check(), city_illness_strike(), dai_effect_value(), and update_city_activity().

## ◆ illness_trade

int city::illness_trade

Definition at line 370 of file city.h.

Referenced by city_illness_calc(), city_illness_strike(), handle_city_info(), package_city(), and update_city_activity().

## ◆ info_units_present

struct unit_list* city::info_units_present

Definition at line 474 of file city.h.

Referenced by city_dialog_update_present_units(), city_packet_common(), create_city_virtual(), destroy_city_virtual(), num_present_units_in_city(), redraw_army_city_dialog(), and city_dialog::update_units().

## ◆ info_units_supported

struct unit_list* city::info_units_supported

Definition at line 473 of file city.h.

Referenced by city_dialog_update_supported_units(), city_packet_common(), create_city_virtual(), destroy_city_virtual(), num_supported_units_in_city(), redraw_supported_units_city_dialog(), and city_dialog::update_units().

## ◆ last_turns_shield_surplus

int city::last_turns_shield_surplus

Definition at line 392 of file city.h.

Referenced by city_change_production_penalty(), city_distribute_surplus_shields(), handle_city_info(), package_city(), sg_load_player_city(), and sg_load_player_city().

## ◆ length

size_t city::length

Definition at line 417 of file city.h.

Referenced by city_build_unit(), city_create_unit(), city_rally_point_clear(), city_rally_point_receive(), package_city(), sg_load_counters(), and sg_load_player_city().

## ◆ martial_law

citizens city::martial_law

Definition at line 338 of file city.h.

Referenced by citizen_happy_units(), and city_support().

## ◆ mgr_score_calc_turn

int city::mgr_score_calc_turn

Definition at line 432 of file city.h.

Referenced by city_migration_score(), and create_city_virtual().

## ◆ migration_score

float city::migration_score

Definition at line 431 of file city.h.

Referenced by city_migration_score().

## ◆ name

char* city::name

Definition at line 321 of file city.h.

Referenced by trade_generator::add_city(), city_name_get(), city_name_set(), city_remove_improvement(), destroy_city_virtual(), handle_city_info(), handle_city_short_info(), handle_edit_city(), objbind_get_value_from_object(), objbind_pack_current_values(), trade_generator::remove_city(), trade_generator::remove_virtual_city(), and texai_req_worker_task_rcv().

## ◆ nationality

citizens* city::nationality

Definition at line 341 of file city.h.

Referenced by citizens_free(), citizens_init(), citizens_nation_add(), citizens_nation_get(), citizens_nation_set(), citizens_reduction_apply(), citizens_update(), city_build(), city_create_unit(), create_city(), and sg_load_player_city_citizens().

## ◆ need_updates

enum city_updates city::need_updates

Definition at line 481 of file city.h.

Referenced by city_report_dialog_update_city(), popup_city_dialog(), and refresh_city_dialog().

## ◆ needs_arrange

enum city_needs_arrange city::needs_arrange

Definition at line 441 of file city.h.

Referenced by auto_arrange_workers(), broadcast_city_info(), city_freeze_workers_queue(), city_thaw_workers(), package_city(), and send_city_info_at_tile().

## ◆ needs_refresh

bool city::needs_refresh

Definition at line 445 of file city.h.

Referenced by city_refresh(), and city_refresh_queue_add().

## ◆ occupied

bool city::occupied

Definition at line 460 of file city.h.

Referenced by city_is_occupied(), client_remove_unit(), fill_sprite_array(), handle_city_info(), handle_city_short_info(), handle_unit_packet_common(), is_plr_zoc_client(), and show_full_citybar().

## ◆ orders

struct unit_order* city::orders

Definition at line 422 of file city.h.

Referenced by city_create_unit(), city_rally_point_clear(), city_rally_point_receive(), package_city(), and sg_load_player_city().

## ◆ original

struct player* city::original

Definition at line 324 of file city.h.

Referenced by city_incite_cost(), city_original_owner(), create_city_virtual(), dai_can_requirement_be_met_in_city(), handle_city_info(), handle_city_short_info(), sg_load_player_city(), sg_load_player_city(), and unit_conquer_city().

## ◆ owner

struct player* city::owner

Definition at line 323 of file city.h.

Referenced by citizens_unit_nationality(), city_change_size(), city_counters_refresh(), city_populate(), city_reduce_size(), create_city_virtual(), dai_upgrade_units(), disband_city(), enable_city_dlg_widgets(), handle_city_info(), handle_city_short_info(), handle_worker_task(), handle_worker_task(), set_city_workertask(), map_view::shortcut_pressed(), test_player_sell_building_now(), texai_city_info_recv(), tile_virtual_new(), and transfer_city().

## ◆ persistent

bool city::persistent

Definition at line 419 of file city.h.

Referenced by city_build_unit(), city_rally_point_clear(), city_rally_point_receive(), package_city(), and sg_load_player_city().

## ◆ pollution

int city::pollution

Definition at line 369 of file city.h.

Referenced by adv_eval_calc_city(), check_pollution(), city_dialog_update_information(), city_dialog_update_information(), city_illness_calc(), city_refresh_from_main_map(), cr_entry_pollution(), handle_city_info(), package_city(), redraw_info_city_dialog(), and city_dialog::update_info_label().

## ◆ prod

int city::prod[O_LAST]

Definition at line 358 of file city.h.

Referenced by adv_eval_calc_city(), citizen_happy_luxury(), city_dialog_update_information(), city_dialog_update_information(), city_gold_worth(), city_production_build_units(), city_refresh_from_main_map(), cm_print_city(), compute_max_stats_heuristic(), cr_entry_luxury(), cr_entry_output(), cr_entry_science(), get_city_dialog_output_text(), get_city_dialog_pollution_text(), handle_city_change(), handle_city_info(), package_city(), real_city_report_dialog_update_city(), redraw_city_dialog(), set_city_production(), set_surpluses(), text_happiness_luxuries(), unhappy_city_check(), update_city_activity(), and city_dialog::update_info_label().

## ◆ production

struct universal city::production

Definition at line 396 of file city.h.

Referenced by adjust_improvement_wants_by_effects(), apply_disaster(), base_city_queue_insert(), building_advisor(), change_build_target(), city_dialog::change_production(), choose_build_target(), cid_encode_from_city(), city_build_building(), city_build_stuff(), city_build_unit(), city_building_impr_or_unit(), city_can_buy(), city_choose_build_default(), city_dialog_update_building(), city_get_queue(), city_increase_size(), city_production_build_shield_cost(), city_production_build_units(), city_production_buy_gold_cost(), city_production_has_flag(), city_production_is_genus(), city_production_name_translation(), city_production_turns_to_build(), city_select_building_callback(), city_select_building_callback(), city_set_queue(), city_turn_notify(), city_worklist_commit(), cityrep_buy(), clipboard_copy_production(), clipboard_send_production_packet(), dai_choose_help_wonder(), define_orig_production_values(), diplomat_sabotage(), disband_city(), get_city_mapview_production(), get_current_construction_bonus(), get_prod_complete_string(), handle_city_change(), handle_city_info(), ok_worklist_editor_callback(), package_city(), popup_worklist_editor(), real_city_report_dialog_update_city(), really_handle_city_buy(), redraw_city_dialog(), city_widget::select_building_something(), send_rally_tile(), sg_load_player_city(), sg_load_player_city(), should_force_recalc(), transfer_city(), city_dialog::update_building(), upgrade_building_prod(), upgrade_unit_prod(), and wonder_benefit().

## ◆ [struct]

struct { ... } city::rally_point

Referenced by city_build_unit(), city_create_unit(), city_rally_point_clear(), city_rally_point_receive(), package_city(), and sg_load_player_city().

## ◆ rapture

int city::rapture

Definition at line 385 of file city.h.

Referenced by city_rapture_grow(), sg_load_player_city(), sg_load_player_city(), and update_city_activity().

## ◆ routes

struct trade_route_list* city::routes

Definition at line 344 of file city.h.

Referenced by city_num_trade_routes(), create_city_virtual(), destroy_city_virtual(), get_city_mapview_trade_routes(), handle_city_info(), handle_trade_route_info(), reestablish_city_trade_routes(), sg_load_player_city(), and sg_load_player_city().

## ◆ [struct]

struct { ... } city::server

Referenced by adjust_improvement_wants_by_effects(), adv_city_alloc(), adv_city_free(), adv_city_update(), adv_city_worker_act_get(), adv_city_worker_act_set(), adv_city_worker_extra_get(), adv_city_worker_extra_set(), adv_city_worker_rmextra_get(), adv_city_worker_rmextra_set(), assess_danger(), auto_arrange_workers(), broadcast_city_info(), building_advisor_choose(), citizens_update(), city_ai_data(), city_freeze_workers(), city_freeze_workers_queue(), city_illness_check(), city_illness_strike(), city_map_update_empty(), city_map_update_radius_sq(), city_map_update_worker(), city_migration_score(), city_refresh(), city_refresh_queue_add(), city_refresh_vision(), city_set_ai_data(), city_thaw_workers(), create_city(), create_city_virtual(), dai_build_adv_override(), dai_choose_help_wonder(), dai_effect_value(), debug_command(), handle_web_cma_set(), military_advisor_choose_build(), package_city(), remove_city(), send_city_info(), send_city_info_at_tile(), sg_load_player_cities(), sg_load_player_cities(), sg_load_player_city(), sg_load_player_city(), show_delegations(), transfer_city(), and update_city_activity().

## ◆ shield_stock

int city::shield_stock

Definition at line 368 of file city.h.

Referenced by actres_possible(), adjust_improvement_wants_by_effects(), apply_disaster(), build_points_left(), change_build_target(), city_build_building(), city_build_unit(), city_can_change_build(), city_dialog_update_building(), city_distribute_surplus_shields(), city_production_build_units(), city_production_buy_gold_cost(), city_turn_notify(), cr_entry_building(), dai_process_defender_want(), dai_spend_gold(), diplomat_incite(), diplomat_sabotage(), get_city_dialog_production(), get_prod_complete_string(), handle_city_info(), handle_edit_city(), military_advisor_choose_build(), objbind_get_value_from_object(), objbind_pack_current_values(), package_city(), popup_worklist_editor(), raze_city(), real_city_report_dialog_update_city(), really_handle_city_buy(), redraw_city_dialog(), sg_load_player_city(), sg_load_player_city(), city_dialog::update_building(), and wonder_benefit().

## ◆ size

citizens city::size

Definition at line 332 of file city.h.

Referenced by apply_disaster(), city_dialog_update_information(), city_dialog_update_information(), city_incite_cost(), city_size_get(), city_size_set(), dai_effect_value(), max_tile_trade(), city_label::mousePressEvent(), show_info_popup(), show_info_popup(), city_map::sizeHint(), tileset_lookup_sprite_tags(), and city_dialog::update_info_label().

## ◆ specialists

citizens city::specialists[SP_MAX]

Definition at line 336 of file city.h.

Referenced by add_specialist_output(), apply_cmresult_to_city(), apply_result_on_server(), apply_solution(), city_add_unit(), city_increase_size(), city_map_update_radius_sq(), city_reduce_specialists(), city_repair_size(), city_specialists(), cm_print_city(), cm_result_copy(), cr_entry_specialist(), cr_entry_specialists(), create_city_virtual(), get_city_citizen_types(), get_entertainers(), handle_city_change_specialist(), handle_city_info(), handle_city_make_specialist(), handle_city_make_worker(), handle_city_short_info(), handle_diplomacy_cancel_pact(), map_change_seen(), military_advisor_choose_build(), package_city(), redraw_city_dialog(), redraw_happiness_city_dialog(), sg_load_player_city(), sg_load_player_city(), and tile_change_side_effects().

## ◆ steal

int city::steal

Definition at line 414 of file city.h.

Referenced by city_dialog_update_information(), city_dialog_update_information(), diplomat_get_tech(), diplomats_unignored_tech_stealings(), handle_city_info(), package_city(), sg_load_player_city(), sg_load_player_city(), and city_dialog::update_info_label().

## ◆ style

int city::style

Definition at line 327 of file city.h.

Referenced by city_style_name_translation(), city_style_refresh(), city_style_rule_name(), handle_city_info(), handle_city_short_info(), package_city(), sg_load_player_city(), sg_load_player_city(), style_of_city(), and update_dumb_city().

## ◆ surplus

int city::surplus[O_LAST]

Definition at line 355 of file city.h.

Referenced by adjust_improvement_wants_by_effects(), adv_eval_calc_city(), auto_arrange_workers(), building_advisor(), city_dialog_update_information(), city_dialog_update_information(), city_distribute_surplus_shields(), city_increase_size(), city_migration_score(), city_populate(), city_rapture_grow(), city_turn_notify(), city_turns_to_build(), city_turns_to_grow(), cm_print_city(), cr_entry_building(), cr_entry_foodplus(), cr_entry_gold(), cr_entry_output(), cr_entry_prodplus(), cr_entry_resources(), cr_entry_tradeplus(), dai_choose_trade_route(), dai_effect_value(), dai_hunter_guess_best(), dai_hunter_missile_want(), dai_unit_make_homecity(), domestic_advisor_choose_build(), evaluate_solution(), get_city_dialog_output_text(), get_city_dialog_production(), get_city_dialog_production_full(), get_city_dialog_production_row(), get_city_mapview_name_and_growth(), get_city_surplus(), get_discounted_reward(), handle_city_info(), military_advisor_choose_build(), military_amortize(), package_city(), popup_worklist_editor(), real_city_report_dialog_update_city(), redraw_city_dialog(), resolve_city_emergency(), set_surpluses(), update_city_activity(), city_dialog::update_info_label(), and wonder_benefit().

## ◆ synced

bool city::synced

Definition at line 448 of file city.h.

Referenced by city_map_update_empty(), city_map_update_worker(), create_city(), handle_web_cma_set(), send_city_info(), sg_load_player_city(), and sg_load_player_city().

## ◆ task_reqs

struct worker_task_list* city::task_reqs

Definition at line 412 of file city.h.

Referenced by clear_worker_task(), clear_worker_tasks(), city_map::context_menu(), create_city_virtual(), destroy_city_virtual(), handle_worker_task(), handle_worker_task(), package_and_send_worker_tasks(), popup_workertask_dlg(), sg_load_player_cities(), sg_load_player_cities(), and texai_req_worker_task_rcv().

## ◆ tile

struct tile* city::tile

Definition at line 322 of file city.h.

Referenced by action_may_happen_unit_on_city(), action_maybe_possible_actor_unit(), action_prob_self_full(), action_prob_vs_city_full(), action_prob_vs_extras_full(), action_prob_vs_stack_full(), action_prob_vs_tile_full(), action_prob_vs_unit_full(), trade_generator::add_tile(), adjust_improvement_wants_by_effects(), adjust_wants_for_reqs(), agents_city_new(), agents_city_remove(), ap_dipl_battle_win(), api_effects_tile_bonus(), api_methods_city_tile_get(), assess_defense_backend(), assess_defense_quadratic(), broadcast_city_info(), button_down_citymap(), can_city_build_improvement_direct(), can_city_build_improvement_later(), can_city_build_unit_direct(), can_city_build_unit_later(), can_disaster_happen(), caravan_find_best_destination_withtransit(), caravan_result_init(), casus_belli_range_for(), city_widget::center(), center_iterate(), center_next_player_capital(), center_on_something(), city_base_to_city_map(), city_change_size(), city_create_unit(), city_dialog_update_present_units(), city_gold_worth(), city_got_defense_effect(), city_incite_cost(), city_landlocked_sell_coastal_improvements(), city_populate(), city_production_unit_veteran_level(), city_reduce_size(), city_select_coastal_callback(), city_select_coastal_callback(), city_style(), city_support(), city_tile_cache_update(), city_tile_output(), city_unit_present(), city_widget::city_view(), cityrep_buy(), client_remove_unit(), city_map::context_menu(), cr_entry_attack(), cr_entry_continent(), cr_entry_defense(), cr_entry_present(), create_city_virtual(), dai_can_city_build_improvement_later(), dai_caravan_can_trade_cities_diff_cont(), dai_choose_defender_versus(), dai_choose_help_wonder(), dai_choose_paratrooper(), dai_choose_trade_route(), dai_city_sell_noncritical(), dai_diplomat_defend(), dai_effect_value(), dai_find_source_building(), dai_hunter_find(), dai_hunter_missile_want(), dai_manage_caravan(), dai_military_attack(), dai_military_defend(), dai_upgrade_units(), dai_wants_defender_against(), defense_multiplication(), diplomat_get_tech(), diplomat_incite(), diplomat_investigate(), diplomat_sabotage(), diplomat_success_vs_defender(), disband_city(), do_heal_unit(), draw_calculated_trade_routes(), dsend_packet_edit_city_create(), dsend_packet_edit_unit_create(), dsend_packet_edit_unit_remove(), fill_city_overlays_sprite_array(), trade_generator::find_certain_routes_inner(), find_city_callback(), find_city_or_settler_near_tile(), find_response(), find_selection_callback(), game_remove_unit(), get_city_bonus(), get_city_tile_output_bonus(), get_tile_bonus(), get_tile_output_bonus(), get_total_attack_power(), get_unit_vs_tile_bonus(), get_unittype_bonus(), goods_can_be_provided(), handle_city(), handle_city_change(), handle_city_info(), handle_city_rename(), handle_city_short_info(), handle_city_update_counters(), handle_diplomacy_create_clause_req(), improvement_obsolete(), is_action_enabled_unit_on_city_full(), is_action_enabled_unit_on_extras_full(), is_action_enabled_unit_on_self_full(), is_action_enabled_unit_on_stack_full(), is_action_enabled_unit_on_tile_full(), is_action_enabled_unit_on_unit_full(), is_city_center(), unit_hud_selector::island_filter(), link_mark_tile(), max_tile_trade(), military_advisor_choose_build(), min_food_surplus_for_fastest_growth(), nearest_gov_center(), num_continent_buildings(), num_present_units_in_city(), paste_tile(), popup_hurry_production_dialog(), popup_incite_dialog(), popup_iterate(), process_attacker_want(), real_city_dialog_refresh(), real_city_log(), really_handle_city_buy(), really_handle_city_sell(), redraw_army_city_dialog(), reestablish_city_trade_routes(), refresh_dumb_city(), trade_generator::remove_city(), trade_generator::remove_virtual_city(), right_button_down_citymap(), same_island_iterate(), sdi_try_defend(), city_widget::select_coastal(), city_widget::select_same_island(), send_city_info(), sg_load_player_city(), sg_load_player_city(), show_full_citybar(), show_units_response(), mr_menu::slot_autocaravan(), switch_city_callback(), teleport_unit_to_city(), toggle_city_color(), transfer_city_units(), unit_attack_civilian_casualties(), unit_bribe_cost(), unit_virtual_create(), update_city_description(), update_dumb_city(), city_dialog::update_units(), upgrade_city_extras(), utype_needs_improvement(), utype_pays_mp_for_action_estimate(), vision_site_update_from_city(), and worklist_item_postpone_req_vec().

## ◆ tile_cache

struct tile_cache* city::tile_cache

Definition at line 349 of file city.h.

Referenced by city_tile_cache_get_output(), city_tile_cache_update(), and destroy_city_virtual().

## ◆ tile_cache_radius_sq

int city::tile_cache_radius_sq

Definition at line 352 of file city.h.

Referenced by city_tile_cache_get_output(), city_tile_cache_update(), and create_city_virtual().

## ◆ turn_founded

int city::turn_founded

Definition at line 386 of file city.h.

Referenced by city_can_buy(), city_comp_by_turn_founded(), create_city_virtual(), handle_city_info(), package_city(), really_handle_city_buy(), sg_load_player_city(), and sg_load_player_city().

## ◆ turn_last_built

int city::turn_last_built

Definition at line 387 of file city.h.

Referenced by adjust_improvement_wants_by_effects(), city_build_building(), city_build_unit(), city_built_last_turn(), create_city_virtual(), handle_city_info(), package_city(), sg_load_player_city(), and sg_load_player_city().

## ◆ turn_plague

int city::turn_plague

Definition at line 374 of file city.h.

Referenced by city_had_recent_plague(), city_illness_strike(), create_city_virtual(), sg_load_player_city(), and sg_load_player_city().

## ◆ unhappy

bool city::unhappy

Definition at line 463 of file city.h.

Referenced by api_methods_is_city_unhappy(), fill_sprite_array(), handle_city_info(), and handle_city_short_info().

## ◆ unhappy_penalty

int city::unhappy_penalty[O_LAST]

Definition at line 357 of file city.h.

Referenced by get_city_dialog_output_text(), get_city_dialog_pollution_text(), handle_city_info(), package_city(), and unhappy_city_check().

## ◆ unit_happy_upkeep

citizens city::unit_happy_upkeep

Definition at line 339 of file city.h.

Referenced by citizen_happy_units(), and city_support().

## ◆ units_supported

struct unit_list* city::units_supported

Definition at line 406 of file city.h.

Referenced by city_balance_treasury_units(), city_dialog_update_supported_units(), city_distribute_surplus_shields(), city_gold_worth(), city_packet_common(), city_populate(), city_support(), city_total_unit_gold_upkeep(), city_unit_slots_available(), city_unit_supported(), city_units_upkeep(), cr_entry_supported(), create_city_virtual(), dai_assess_military_unhappiness(), dai_choose_trade_route(), dai_effect_value(), dai_hunter_find(), destroy_city_virtual(), diplomat_investigate(), disband_city(), game_remove_unit(), handle_unit_packet_common(), num_supported_units_in_city(), place_unit(), redraw_supported_units_city_dialog(), remove_city(), resolve_city_emergency(), sg_load_player_units(), sg_load_player_units(), transfer_city(), transfer_city_units(), update_city_activity(), and city_dialog::update_units().

## ◆ usage

int city::usage[O_LAST]

Definition at line 360 of file city.h.

Referenced by city_support(), get_city_dialog_output_text(), handle_city_info(), init_min_production(), package_city(), set_city_production(), set_surpluses(), and unhappy_city_check().

## ◆ vigilant

bool city::vigilant

Definition at line 421 of file city.h.

Referenced by city_create_unit(), city_rally_point_clear(), city_rally_point_receive(), package_city(), and sg_load_player_city().

## ◆ vision

struct vision* city::vision

Definition at line 455 of file city.h.

Referenced by city_refresh_vision(), create_city(), remove_city(), sg_load_player_cities(), sg_load_player_cities(), and transfer_city().

## ◆ walls

int city::walls

Definition at line 461 of file city.h.

Referenced by fill_sprite_array(), handle_city_info(), and handle_city_short_info().

## ◆ was_happy

bool city::was_happy

Definition at line 381 of file city.h.

Referenced by base_city_celebrating(), handle_city_info(), package_city(), sg_load_player_city(), sg_load_player_city(), and update_city_activity().

## ◆ waste

int city::waste[O_LAST]

Definition at line 356 of file city.h.

Referenced by city_dialog_update_information(), city_dialog_update_information(), cityresult_fill(), cr_entry_corruption(), cr_entry_waste(), get_city_dialog_output_text(), handle_city_info(), package_city(), real_city_report_dialog_update_city(), redraw_city_dialog(), set_city_production(), and city_dialog::update_info_label().

## ◆ wlcb

enum city_wl_cancel_behavior city::wlcb

Definition at line 404 of file city.h.

Referenced by create_city_virtual(), sg_load_player_city(), sg_load_player_city(), and worklist_item_postpone_req_vec().

## ◆ workers_frozen

int city::workers_frozen

Definition at line 437 of file city.h.

Referenced by auto_arrange_workers(), city_freeze_workers(), and city_thaw_workers().

## ◆ worklist

struct worklist city::worklist

Definition at line 401 of file city.h.

Referenced by base_city_queue_insert(), city_build_unit(), city_dialog_update_building(), city_get_queue(), city_production_build_units(), city_queue_clear(), city_queue_insert(), city_queue_insert_worklist(), city_set_queue(), cr_entry_building(), create_city_virtual(), handle_city_info(), handle_city_worklist(), package_city(), popup_worklist_editor(), real_city_report_dialog_update_city(), sg_load_player_city(), sg_load_player_city(), worklist_change_build_target(), and worklist_next_to_last_impr_or_unit_iterate().